;------------------------------------------------------------------------------
; NRDSEL2D.ASM
;------------------------------------------------------------------------------
KEYVECT			EQU	$64		; L[͊荞݃xNg
WIDTH			EQU	80		; ʉTCY
NRTDRV_LOADADRS		EQU	$1300		; NRTDRV̓ǂݍ݊JnAhX
DATA_LOAD_ADRS		EQU	$4000		; NRDt@C̓ǂݍ݊JnAhX
;------------------------------------------------------------------------------
FILENAME_LEN		EQU	16		; t@C̒
STRBUF_LEN		EQU	WIDTH		; obt@̃TCY
MUSICTITLE_LEN		EQU	WIDTH-5		; \鉹y^Cg̍ő咷
;------------------------------------------------------------------------------
	ORG	$0000
START:				; (RST 00) Cs
	DI			; 0000	4	f3
	JP 	BOOT		; 0001	10	C3 xx xx
EXTENSION:
	DB	"NRD"		; 0002
	NOP
;------------------------------------------------------------------------------
PATCHGVRAM08:			; (RST 08) HL̎AhXI/OA̒lo [7byte]
	LD	B, H		; 0008	4	44
	LD	C, L		; 0009	4	4d
	OUT	(C), A		; 000a	12	ed 79
	LD	B, $0f		; 000c	7	06 0f	 FDCɕA
	RET			; 000e	10	c9
;------------------------------------------------------------------------------
	ORG	$0018

CALLBIOS:			; (RST 18) BIOSR[ [10byte] BC=AhX
	CALL	$001b		; 0018		cd xx xx
	PUSH	BC		; 001b		c5
	LD	B, $1d		; 001c	7	06 1d	1dxx=IPL(BIOS) ROM ON
	OUT	(C), B		; 001e	12	ed 41
	RET			; 0020	10	c9
;------------------------------------------------------------------------------
	ORG	$0064

_KEYVECT:			; L[͊荞݃xNg
	NOP			; 0064	4	00
	NOP			; 0065	4	00
;------------------------------------------------------------------------------
				; NMI
	RETN			; 0066

;------------------------------------------------------------------------------

	ORG	$0100
	JP	BOOT

TEXT_NRDSEL:
	DB	"NRTDRV music file playback selector - NRDSEL[2D] / 20111023", $00

;------------------------------------------------------------------------------

	ORG	$0144

	RET		; ]PCGSET͖
	NOP
	NOP

;------------------------------------------------------------------------------
BOOT:
	DI
	IM	2
	LD	SP, $0000
	XOR	A
	LD	I, A
	;----------------------------------------------------------------------
	CALL	CLEARGRAM		; GRAM
	CALL	CLEARTEXT		; eLXgVRAM
	CALL	INITCRTC		; CRTC
	;----------------------------------------------------------------------
	LD	BC, $3000		; 
	LD	E, 7			; Agr[g
	LD	HL, MSG_WAIT		; Ƃ܂Ă˕\
	CALL	PRINT3
	;----------------------------------------------------------------------
	CALL	HARDCHECK		; X1/turbo/Z胋[`
	CALL	INITDRIVE		; FDDݒ胋[`
	CALL	OPMBOARDCHECK		; FM{[h̃`FbN
	CALL	INITJOYSTICK		; WCXeBbN͏
	;----------------------------------------------------------------------
	; L[͐ݒ
	LD	A, KEYVECT		; 荞݃xNgi$00xxj
	LD	HL, INTKEY		; 荞݃[`̊JnAhX
	CALL	SETKEYVECT		
;------------------------------------------------------------------------------
DEFINEPCG:
	LD	DE, PCGFILE
	CALL	SET_FILENAME		; [ht@Cݒ
	LD	HL, DATA_LOAD_ADRS
	CALL	FILELOAD		; t@C[h
	JR	NC, DEFINEPCG02
	;----------------------------------------------------------------------
	CALL	SHOW_INITIAL_STATUS	; ÑG[bZ[W\
	JR	DEFINEPCG		; gC
DEFINEPCG02:
	LD	HL, $4000	; 
	CALL	PCGSET		; PCG`s
;------------------------------------------------------------------------------
; for debug (PCGS\)
;	CALL	SHOW_ALL_PCG
;------------------------------------------------------------------------------
LOAD_NRTDRV:
	LD	DE, FILENAME_DRV	; [ht@C
	CALL	SET_FILENAME


	LD	HL, NRTDRV_LOADADRS	; [hAhX
	CALL	FILELOAD
	JR	NC, GO_NRTDRV

	CALL	SHOW_INITIAL_STATUS	; ǂݍ݃G[̏
	JR	LOAD_NRTDRV
;------------------------------------------------------------------------------
GO_NRTDRV:
	CALL	$1300			; DRVINI
	;----------------------------------------------------------------------
	CALL	CLEARTEXT		; eLXgVRAM
	;----------------------------------------------------------------------
	LD	A, $ff
	CALL	$1315			; VINIT
	;----------------------------------------------------------------------
	CALL	DRAW_SCREEN		; ʕ`
	;----------------------------------------------------------------------
	LD	BC, FILELIST_DRAWSTART-WIDTH-3	; t[\
	LD	H, FILENAME_LEN+5
	LD	L, SHOWFILECOUNT
	CALL	DRAWFRAME
	;----------------------------------------------------------------------
	CALL	REFRESH_FILELIST	; t@CXg擾
	CALL	DRAW_MFILELIST		; t@CXg`
;------------------------------------------------------------------------------
MAIN:
	EI
	CALL	WAITVDISP		; V-BLANKҋ@
	CALL	UPDATE_KEYBOARD		; VMAINit`j
	CALL	INPUTCHECK		; L[̓`FbN
	CALL	MSTOP_CHECK		; yf[^I`FbN
	JR	NC, MAIN01		
	XOR	A			; S`lt~tOĂAtI
	LD	(NRTDRV_LOADADRS+$21),A	; PLYFLG~(0)ɂi]CcȂȂ̂ŉt~͂Ȃj
MAIN01:
	LD	A, (PLAYMODE)		; t[h̊mF
	AND	00000011B
	AND	A
	JR	Z, MAIN02		; SINGLE PLAY[h̏ꍇ͖[ṽ`FbNȂ
	CALL	LOOP_CHECK		; [vJEg̃`FbN
	JR	NC, MAIN02
	CALL	_FADEOUT
MAIN02:
	LD	A, (NRTDRV_LOADADRS+$21)
	AND	A			; ~Ȃ
	CALL	Z, BRANCH		; t[hɉs

	CALL	GET_PLAYSTATUS		; ݂̉tԂ擾
	CALL	SHOW_STATUS		; ݂̉tԂ\

	JR	MAIN			; CJԂ

;------------------------------------------------------------------------------
BRANCH:
	LD	A, (PLAYMODE)
	AND	00000011B
	ADD	A, A
	LD	HL, BRANCHDATA
	CALL	ADDHLA
	LD	E, (HL)
	INC	HL
	LD	D, (HL)
	EX	DE, HL
	JP	(HL)

BRANCHDATA:
	DW	RETURN			; SINGLE PLAYiȂɂȂj
	DW	PLAYNEXT		; AUTO PLAY
	DW	PLAYPREV		; REVERSE PLAY
	DW	PLAYRANDOM		; RANDOM PLAY

;------------------------------------------------------------------------------
; V-DISPҋ@
WAITVDISP:
	LD	BC, $1a01
WAITVDISP01:
	IN	A, (C)
	JP	P, WAITVDISP01
WAITVDISP02:
	IN	A, (C)
	JP	M, WAITVDISP02
RETURN:
	RET

;------------------------------------------------------------------------------
UPDATE_KEYBOARD:
	JP	$1318			; VMAINit`j
					; (Tu[`RETŃCɕA)
;------------------------------------------------------------------------------
DRAW_SCREEN:
	CALL	DRAW_NRTDRV_LOGO	; NRTDRVS\
	CALL	DRAW_HARDWARE_INFO	; n[hEFA\
	CALL	DRAW_OPTION_INFO	; IvV\
	CALL	DRAW_STATUS		; STATUS\
	CALL	DRAW_MTITLE		; Ȗ/Ȏ/ҕ\
	RET

;------------------------------------------------------------------------------
DRAW_MFILELIST:
	CALL	CALC_LIST		; y[WvZ
	CALL	ERASE_LIST		; `̈
	CALL	DRAW_LIST		; Xg`
	CALL	DRAW_CURSOR		; J[\`
	CALL	DRAW_DRIVE		; hCu/y[W\
	RET

;------------------------------------------------------------------------------
; L[́WCXeBbN̓`FbN
INPUTCHECK:
KEYCHECK:
	; L[̓`FbN
	LD	A, (KEYFUNC)
	BIT	6, A
	JR	NZ, JOYCHECK		; L[͂ȂWCXeBbN̓`FbN
	;----------------------------------------------------------------------
	; L[͔
	LD	A, (KEYASCII)		; ꂽL[ASCIIl
	LD	E, A			; ꎞۑ
	CALL	CHECKKEYLP		; L[܂őҋ@
	LD	A, E			; A
	LD	BC, KEYCOUNT		; `FbNL[̌
	LD	HL, KEYDATA+KEYCOUNT-1	; L[e[u[
	CPDR				; 납rBvZtO
	RET	NZ			; vL[͂Ȃ甲
	LD	HL, KEYJUMPTBL		; Wve[u擪
	JR	KEYJUMP
;------------------------------------------------------------------------------
JOYCHECK:
	; WCXeBbN̓`FbN
	CALL	JOYCHECKA		; ̓`FbN
	RET	Z			; ͂Ȃ甲
	LD	E, A			; ꎞۑ
JOYCHECK01:
	CALL	JOYCHECKA		; ̓`FbN
	JR	NZ, JOYCHECK01		; ͒Ȃ痣܂őҋ@
	LD	A, E
JOYCHECK02:
	; WCXeBbN͔
	LD	BC, JOYCOUNT		; `FbNL[̌
	LD	HL, JOYDATA+JOYCOUNT-1	; L[e[u[
	CPDR				; 납r
	RET	NZ			; vL[͂Ȃ甲
	LD	HL, JOYFUNC		; Wve[u擪
	;----------------------------------------------------------------------
KEYJUMP:
	; Wvm
	SLA	C			; index~2
;	RL	B			; (ѐ悪128ȉ̎͊mB=0ɂȂ̂ŕsv)
	ADD	HL, BC			; WvAhX擾
TBLJUMP:
	LD	E, (HL)			; HLɃRs[
	INC	HL
	LD	D, (HL)
	EX	DE, HL
	JP	(HL)			; Tu[`ցiTu[`RETŃCɕAj
;------------------------------------------------------------------------------
JOYCHECKA:
	; WCXeBbNA̓`FbN
	LD	BC, $1c0e		; B=WX^w($1cxx), C=|[gA(14)
	DI				; 肱݂
	OUT	(C), C			; WCXeBbN|[gWX^w
	DEC	B			; B=f[^I/O($1bxx)
	IN	A, (C)			; ̓f[^擾
	CP	$ff			; ͂H(͂ȂZtO)
	EI				; 肱݂傩
	RET

;==============================================================================
; L[̓C^[tF[Xij
;==============================================================================
; L[{[h́EWve[u
KEYCOUNT	EQU	18		; 
KEYDATA:
	DB	"R"
	DB	"r"
	DB	"P"
	DB	"p"
	DB	"S"
	DB	"s"
	DB	"F"
	DB	"f"
	DB	"T"
	DB	"t"
	DB	"M"
	DB	"m"
	DB	$1c	; 
	DB	$1d	; E
	DB	$1e	; 
	DB	$1f	; 
	DB	" "	; space		; L[
	DB	13	; return
;------------------------------------------------------------------------------
KEYJUMPTBL:
	DW	REDRAW_FILELIST		; R		t@CXgXV
	DW	REDRAW_FILELIST		; r		t@CXgXV
	DW	PLAYMUSIC		; P		tJn
	DW	PLAYMUSIC		; p		V
	DW	$1306			; S		t~(MSTOP)
	DW	$1306			; s		V
	DW	_FADEOUT		; f		tF[hAEg
	DW	_FADEOUT		; f		V
	DW	PLAYTEST		; T		MTEST
	DW	PLAYTEST		; t		MTEST
	DW	CHANGEMODE		; M
	DW	CHANGEMODE		; m
	DW	DRIVE_UP		; 		hCuԍ+1
	DW	DRIVE_DOWN		; E		hCuԍ-1
	DW	SELECT_UP		; 		It@C+1
	DW	SELECT_DOWN		; 		It@C-1
	DW	LOAD_MDATA		; space		t@Cǂݍ
	DW	LOADANDPLAY		; return	t@Cǂݍŉt

;==============================================================================
; WCXeBbN̓C^[tF[Xij
;==============================================================================
; WCXeBbŃEWve[u
JOYCOUNT	EQU	6		; `
JOYDATA:				; L[
	DB	11111110B	; $fe 
	DB	11111101B	; $fd 
	DB	11111011B	; $fb 
	DB	11110111B	; $f7 E
	DB	11011111B	; $df trigger1
	DB	10111111B	; $bf trigger2
	;       ||||||||
	;       |||||||	_
	;       ||||||
	;       |||||
	;       ||||E
	;       |||gp
	;       ||trigger1
	;       |trigger2
	;	GND
; -----------------------------------------------------------------------------
JOYFUNC:
	DW	SELECT_UP		; 		It@C+1
	DW	SELECT_DOWN		; 		It@C-1
	DW	DRIVE_DOWN		; 		hCuԍ-1
	DW	DRIVE_UP		; 		hCuԍ+1
	DW	LOAD_MDATA		; trigger1
	DW	TOGGLEPLAY		; trigger2


;==============================================================================
; Tu[`
;==============================================================================
; t[h؂ւ
CHANGEMODE:
	LD	A, (PLAYMODE)
	INC	A
	AND	00000011B
	LD	(PLAYMODE), A
	RET

; -----------------------------------------------------------------------------
; hCuI(-1)
DRIVE_DOWN:
	LD	A, (CURRENTDRIVE)	; ݃hCuԍ擾(0X^[g)
	AND	A
	JR	NZ, DRIVE_DOWN01

	LD	A, (DRIVECOUNT)		; ڑhCu擾
	AND	A			; ڑhCu0ĂƂ͂肦ȂǁEEEꉞ`FbN
	RET	Z
DRIVE_DOWN01:
	DEC	A			; ŏIhCuԍ(ڑhCu-1)
; -----------------------------------------------------------------------------
; hCuIisj
DRIVE_SET:
	CALL	SETDRIVE		; hCuIs
; -----------------------------------------------------------------------------
; t@CXgĕ`
REDRAW_FILELIST:
	CALL	ERASE_CURSOR		; J[\
	CALL	REFRESH_FILELIST	; t@CXg擾
	CALL	DRAW_MFILELIST		; t@CXg\
	RET

; -----------------------------------------------------------------------------
; hCuI(+1)
DRIVE_UP:
	LD	A, (DRIVECOUNT)		; ڑhCu擾
	LD	B, A
	LD	A, (CURRENTDRIVE)	; ݃hCuԍ擾(0X^[g)
	INC	A			; +1
	CP	B
	JR	C, DRIVE_SET		; hCuIs

	XOR	A			; őlI[o[̏ꍇ0ɐݒ
	CALL	SETDRIVE		; hCuIs
	CALL	REDRAW_FILELIST

	RET


; -----------------------------------------------------------------------------
; RANDOMPLAY[hEׂɉt
PLAYRANDOM:
	CALL	ERASE_CURSOR

	LD	A, (NOWPLAYINDEX)	; ݉t̋index
	LD	D, A			; ꎞۑ
	LD	E, 16			; Ďs񐔁iKj

PLAYRANDOM01:
	LD	A, (FILECOUNT)		; NRDt@C擾
	AND	A
	RET	Z			; NRDt@C0Ȃ߂

	LD	B, A
	LD	A, R
	SET	7, A

	CALL	DIVAB			; s萔t@C

	CP	D			; ]OlƔr
	JR	NZ, PLAYRANDOM02	; ႤlȂ̗p

	DEC	E
	JR	NZ, PLAYRANDOM01	; Ďs

PLAYRANDOM02:

	CALL	SAVE_POSITION

	CALL	LOADANDPLAY

	RET

; -----------------------------------------------------------------------------
; REVERSEPLAY[hEŐȂt
PLAYPREV:
	CALL	ERASE_CURSOR

	LD	A, (NOWPLAYINDEX)	; ݉t̋index
	DEC	A
	CALL	SELECT_UP01

	LD	A, (FILECOUNT)		; NRDt@C擾
	AND	A
	RET	Z			; NRDt@C0Ȃ߂

	CALL	LOADANDPLAY

	RET

; -----------------------------------------------------------------------------
; AUTOPLAY[hE̋Ȃt
PLAYNEXT:
	CALL	ERASE_CURSOR

	LD	A, (NOWPLAYINDEX)	; ݉t̋index
	INC	A
	CALL	SELECT_DOWN01

	LD	A, (FILECOUNT)		; NRDt@C擾
	AND	A
	RET	Z			; NRDt@C0Ȃ߂

	CALL	LOADANDPLAY

	RET

; -----------------------------------------------------------------------------
; yt@CIiړj
SELECT_UP:
	CALL	ERASE_CURSOR
	LD	A, (CURSORPOS)		; ݃|C^擾
	DEC	A			; index-1

SELECT_UP01:
	LD	B, A
	LD	A, (FILECOUNT)		; NRDt@C擾
	AND	A
	RET	Z			; NRDt@C0Ȃ߂

	DEC	A			; t@CȂ̂1X^[g̒l0X^[g̒lɂ
	CP	B			; Ђ

	JR	C, SAVE_POSITION	; 
	LD	A, B
	JR	SAVE_POSITION

; -----------------------------------------------------------------------------
; yt@CIiړj
SELECT_DOWN:
	CALL	ERASE_CURSOR
	LD	A, (CURSORPOS)
	INC	A			; index+1

SELECT_DOWN01:
	LD	B, A
	LD	A, (FILECOUNT)
	AND	A
	RET	Z

	DEC	A
	CP	B

	LD	A, B
	JR	NC, SAVE_POSITION
	XOR	A
; -----------------------------------------------------------------------------
; yt@CIisj
SAVE_POSITION:
	LD	(CURSORPOS), A		; indexlۑ
	CALL	DRAW_CURSOR		; J[\`
	CALL	DRAW_LIST		; Xg`
	CALL	DRAW_DRIVE		; hCu/y[W\
	RET

; -----------------------------------------------------------------------------
; 񖖒[($00)ɂȂ܂ŁAƂ΂
CUT01:
	LD	A, (DE)
	INC	DE
	AND	A
	JR	NZ, CUT01
	RET

; -----------------------------------------------------------------------------
; FDC̃G[R[hɑΉbZ[WʒuԂ
GET_DISKERRMES:
	LD	A, (DISKERROR)
	AND	10011000B
	;       00000000B
	;       ||||||||
	;       |||||||busy
	;       ||||||DataRequest
	;       |||||LostData
	;       ||||CRC Error
	;       |||RecordNotFound
	;       ||RecordType
	;       |0
	;	NotReady

	BIT	7, A
	JR	NZ, SETMES01
	BIT	4, A
	JR	NZ, SETMES02
	BIT	3, A
	JR	NZ, SETMES03
	AND	A
	JR	NZ, SETMES04

	LD	DE, MSG_UNKNOWN		; ̑̃G[(FDCG[R[h0)

	RET
SETMES01:
	LD	DE, MSG_NOTINSERTED	; fBXN}ĂȂ
	RET
SETMES02:
	LD	DE, MSG_SEEKERROR	; seek error
	RET
SETMES03:
	LD	DE, MSG_CRCERROR	; crc error
	RET
SETMES04:
	LD	DE, MSG_DERROR		; ̑̃G[(G[R[h0łȂ)
	RET

; -----------------------------------------------------------------------------
; ݂̉tԂɑΉbZ[WʒuԂ
GET_PLAYSTATUS:
	LD	B, 16				; StringBufferɓ]钷
	LD	A, (NRTDRV_LOADADRS+$21)	; PLYFLG擾
	CP	1
	JR	C, PLAYSTATUS01	; 0=~
	JR	Z, PLAYSTATUS02	; 1=t
	CP	2
	JR	Z, PLAYSTATUS03	; 2=tF[hAEg
	CP	4
	JR	Z, PLAYSTATUS04	; 4=tF[hAEg
	LD	DE, TEXT_UNKNOWN
	RET
PLAYSTATUS01:
	LD	DE, TEXT_STOP
	RET
PLAYSTATUS02:
	LD	DE, TEXT_PLAY
	RET
PLAYSTATUS03:
	LD	DE, TEXT_FADEOUT
	RET
PLAYSTATUS04:
	LD	DE, TEXT_FADEOUT
	RET

; -----------------------------------------------------------------------------
; ȃf[^[hĉt
LOADANDPLAY:
	CALL	LOAD_MDATA
	RET	C

;------------------------------------------------------------------------------
; tJn[`
PLAYMUSIC:
	LD	A, (ISLOADED)
	AND	A
	RET	Z			; [hĂȂꍇ͏f

	CALL	$1312	; MPLAYD

;------------------------------------------------------------------------------
; Ȗ\
REFRESH_MUSICTITLE:
	LD	DE, DATA_LOAD_ADRS+41	; ȃ^Cgʒu

	LD	A, (RESOFLG)
	AND	A
	JR	NZ, REFRESH_MUSICTITLE01

	LD	A, (HARDFLG)
	AND	A
	JR	Z, REFRESH_MUSICTITLE01
	;----------------------------------------------------------------------
	; HURESOturboȍ~̏ꍇ
	CALL	CUT01

	PUSH	DE
	LD	B, MUSICTITLE_LEN
	CALL	SET_STRINGBUFFER	; obt@ɓ]
	LD	A, MUSICTITLE_LEN	; A =
	LD	BC, $3646-1		; BC=I/OAhX
	CALL	PRINT_KANJI
	POP	DE
	
	CALL	CUT01

	; 傭
	PUSH	DE
	LD	B, 32
	CALL	SET_STRINGBUFFER	; obt@ɓ]
	LD	A, 32			; A =
	LD	BC, $3646+240-1		; BC=I/OAhX
	CALL	PRINT_KANJI
	POP	DE

	CALL	CUT01

	; Ђ
	LD	B, 32
	CALL	SET_STRINGBUFFER	; obt@ɓ]

	LD	A, 32			; A =
	LD	BC, $3646+240+40-1	; BC=I/OAhX
	CALL	PRINT_KANJI

	XOR	A		; cyNA
	RET
	;----------------------------------------------------------------------
REFRESH_MUSICTITLE01:
	; LORESO  X1̏ꍇ
	PUSH	DE
	LD	B, MUSICTITLE_LEN
	CALL	SET_STRINGBUFFER	; obt@ɓ]
	LD	D, MUSICTITLE_LEN	; D =
	LD	BC, $3646-1		; BC=I/OAhX
	CALL	PRINT_ANK
	POP	DE

	CALL	CUT01
	CALL	CUT01

	; 傭
	PUSH	DE
	LD	B, 32
	CALL	SET_STRINGBUFFER	; obt@ɓ]
	LD	D, 32			; D =
	LD	BC, $3646+240-1		; BC=I/OAhX
	CALL	PRINT_ANK
	POP	DE

	CALL	CUT01

	; Ђ
	LD	B, 32
	CALL	SET_STRINGBUFFER	; obt@ɓ]

	LD	D, 32			; D =
	LD	BC, $3646+240+40-1	; BC=I/OAhX
	CALL	PRINT_ANK

	RET

; -----------------------------------------------------------------------------
TOGGLEPLAY:
	LD	A, (NRTDRV_LOADADRS+$21)	; PLYFLG擾
	CP	1
	JP	C, PLAYMUSIC	; 0(~)Ȃ牉tJn
	JP	Z, $1306	; 1(Đ)Ȃ牉t~
	RET			; ̑͂ȂɂȂ

;------------------------------------------------------------------------------
; Ȗ
CLEAR_MTITLE:
	LD	DE, TEXT_CLEAR
	JR	PLAYTEST01

;------------------------------------------------------------------------------
; eXgg[tJn[`
PLAYTEST:
	CALL	$1306			; MSTOP
	CALL	$130F			; MTEST

	XOR	A
	LD	(PLAYMODE), A		; SINGLEPLAY[hɕύXiAUTOPLAŶ܂܂Əɓǂݍł܂̂Łj

	LD	DE, TEXT_TEST		; ȃ^Cgʒu
PLAYTEST01:
	LD	B, MUSICTITLE_LEN
	CALL	SET_STRINGBUFFER	; obt@ɓ]

	LD	A, MUSICTITLE_LEN	; A =
	LD	BC, $3646-1		; BC=I/OAhX
	CALL	PRINT_KANJI		; \(VRAMɂ܂Ă̂ł)

	; 傭/ЂƂ
	LD	DE, TEXT_CLEAR
	LD	B, MUSICTITLE_LEN
	CALL	SET_STRINGBUFFER	; obt@ɓ]

	LD	BC, $3646+240-1		; BC=I/OAhX
	LD	A, MUSICTITLE_LEN
	CALL	PRINT_KANJI		; \(VRAMɂ܂Ă̂ł)

	RET

; -----------------------------------------------------------------------------
; ȃf[^[h
LOAD_MDATA:
	LD	A, (FILECOUNT)		; NRDt@C擾
	AND	A
	RET	Z			; NRDt@C0Ȃ߂

	LD	A, 1
	LD	(FADEOUT+1), A		; fadeout xwiȏj

	CALL	FADEOUT			; tF[hAEgiI҂j

	LD	DE, TEXT_LOAD		; ǂݍݒ\
	CALL	SHOW_STATUS

	CALL	CLEAR_MTITLE		; y^Cg

	LD	A, (CURSORPOS)		; J[\ʒu(indexl)擾
	LD	(NOWPLAYINDEX), A	; indexlۑ

	LD	B, A
	LD	A, (FILENAMELEN)	; t@C擾
	CALL	AXBHL			; AxB=HL

	LD	DE, FILELIST_MEM_START	; DE=t@CAhX擪
	ADD	HL, DE
	EX	DE, HL

	CALL	SET_FILENAME		; t@C]

	LD	HL, $4000
	CALL	FILELOAD
	JR	C, FAILURE_LOAD		; ǂݍݎs̏

	LD	A, $ff
	LD	(ISLOADED) ,A		; [hς݃tO

	CALL	REFRESH_MUSICTITLE	; y^Cg̕\

	RET

;------------------------------------------------------------------------------
FAILURE_LOAD:
	; G[
	CALL	GET_DISKERRMES		; G[bZ[W擾
	CALL	SHOW_STATUS_ERROR	; A\
	CALL	CANCEL_CHECK		; L[͑ҋ@

	XOR	A
	LD	(ISLOADED) ,A		; [hstO
	LD	(PLAYMODE), A		; SINGLEPLAY[hɕύXiAUTOPLAŶ܂܂Ɠǂݍ݂ςȂɂȂ̂Łj

	RET

;------------------------------------------------------------------------------
; tF[hAEg
_FADEOUT:
	LD	A, 5
	LD	(FADEOUT+1), A		; ȏ

FADEOUT:
	LD	A, $ff
	AND	00001111B

	LD	(NRTDRV_LOADADRS+$24), A	; tF[hAEgxݒ

	CALL	$1309			; MFADE

	LD	DE, TEXT_FADEOUT	; tF[hAEg\
	CALL	SHOW_STATUS

FADEOUT01:
	CALL	WAITVDISP		; VDISPҋ@
	CALL	UPDATE_KEYBOARD		; tԕ\

	LD	A, (NRTDRV_LOADADRS+$21)	; PLYFLG擾
	AND	A		; 
	RET	Z		; 0(~)Ȃ߂

	CP	3
	JR	NC, FADEOUT02	; 4ȏȂ...4(tF[hAEgI)Ȃҋ@[vEo
	JR	FADEOUT01	; 1(t)2(tF[hAEg)Ȃēx`FbN

FADEOUT02:
	CALL	$1306		; MSTOP

	RET

; -----------------------------------------------------------------------------
; L[͂܂őҋ@
CANCEL_CHECK:
	LD	A, (KEYASCII)		; L[擾
	AND	A
	JR	NZ, CANCEL_CHECK02	; L[͂ΏI
JOYCANCEL_CHECK:
	CALL	JOYCHECKA		; WCXeBbN̓`FbN
	JR	NZ, JOYCANCEL_CHECK01	; ͒H
	JR	CANCEL_CHECK		; ͂Ȃx`FbN
JOYCANCEL_CHECK01:
	CALL	JOYCHECKA		; WCXeBbN̓`FbN(܂őҋ@j
	JR	NZ, JOYCANCEL_CHECK01	; ͒Ȃx`FbN
	RET
CANCEL_CHECK02:
	CALL	CHECKKEYLP		; L[͂ȂȂ܂őҋ@
	RET
; -----------------------------------------------------------------------------
DRAW_NRTDRV_LOGO:
	LD	BC, $3007		; NRTDRVS̕\
	LD	HL, NRTDRV_LOGO
	LD	D, 12
	CALL	PRINT2

;	LD	BC, $3000+2000-59	; NRDSELo[W\
;	LD	HL, TEXT_NRDSEL
;	LD	D, 59
;	LD	E, 00000111B
;	CALL	PRINT3

	RET

; -----------------------------------------------------------------------------
DRAW_HARDWARE_INFO:
	LD	BC, $30a1		; "Hardware"̕\
	LD	HL, TEXT_HARDWARE
	CALL	PRINT

	LD	A, (HARDFLG)		; @햼\
	CP	1
	JR	C, SHOW_NORMAL
	JR	Z, SHOW_TURBO
SHOW_TURBO_Z:
	LD	A, 13			; A=
	JR	DRAW_PLATFORM
SHOW_TURBO:
	LD	A, 10
	JR	DRAW_PLATFORM
SHOW_NORMAL:
	LD	A, 5
DRAW_PLATFORM:
	LD	BC, $30f6-1
	LD	D, $b0			; uX1turboZv\PCGf[^擪
	LD	E, 00100111B		; Agr[g(PCGgp)
DRAW_PLATFORM01:
	CALL	PUTTEXT
	INC	D
	DEC	A
	JR	NZ, DRAW_PLATFORM01

	INC	BC			; "series"̕\
	LD	HL, TEXT_SERIES
	LD	D, 16		; \
	LD	E, 00000111B	; PCG\ɂȂ
	CALL	PRINT3

	RET

; -----------------------------------------------------------------------------
DRAW_OPTION_INFO:
	LD	BC, $3191		; "Option"̕\
	LD	HL, TEXT_OPTION
	CALL	PRINT

	LD	BC, $31e6-1		; Ђ傤

	LD	D, 16		; \镶
	LD	E, 00000111B	; PCG\ɂȂ

	LD	A, (HARDFLG)
	BIT	7, A
	JR	NZ, OPTION_TURBOZ	; turboZ̏ꍇ͕ʏ

	LD	A, (OPMCOUNT)		; OPM̃`FbN
	AND	00000011B

	CP	1
	JR	C, DRAW_OPTION_NONE	; 0̏ꍇ(Ȃ)
	JR	Z, DRAW_OPTION_NORMAL	; 1̏ꍇ(m[}FM{[h)

	CP	2
	JR	Z, DRAW_OPTION_MODIFIED	; 2̏ꍇ(FM{[h)

	CALL	DRAW_OPTION_NORMAL	; ̑3̏ꍇm[}FM{[h
	JR	NZ, DRAW_OPTION_MODIFIED
	INC	BC

DRAW_OPTION_MODIFIED:
	LD	HL, TEXT_OPMBOARD	; FM{[h̕\
	CALL	PRINT3
	RET

DRAW_OPTION_NORMAL:
	LD	HL, TEXT_OPMBOARD	; ʏFM{[h̕\
	LD	D, 7
	CALL	PRINT3
	RET

OPTION_TURBOZ:				; turboZ̏ꍇ
	LD	A, (OPMCOUNT)		; OPM̃`FbN
	AND	00000011B
	CP	3
	JR	Z, DRAW_OPTION_MODIFIED	; 3̏ꍇ(FMFM{[h)
;	JR	DRAW_OPTION_NONE	; ̑̓m[}FM{[hĂ̂ŁuȂv\

DRAW_OPTION_NONE:
	LD	HL, TEXT_NONE		; g{[hȂ̕\
	CALL	PRINT3
	RET

; -----------------------------------------------------------------------------
; Xe[^X\
DRAW_STATUS:
	LD	BC, $3281		; "Status"̕\
	LD	HL, TEXT_STATUS
	CALL	PRINT

	RET

; -----------------------------------------------------------------------------
; Xe[^X\iXe[^X̂݁j
SHOW_STATUS:
	LD	A, 00000100B		; ȏiAgr[gj
	LD	(SHOW_STATUS02+1), A

SHOW_STATUS01:
	; DE=bZ[WAhX
	LD	B, 16
	CALL	SET_STRINGBUFFER	; obt@ɓ]

	LD	BC, $3286+3
	LD	D, 16		; \
SHOW_STATUS02:
	LD	E, 00100100B	; Agr[g
	CALL	PRINT3

	; SINGLEPLAY/AUTOPLAY̕\
	LD	A, (PLAYMODE)
	AND	00000011B
	LD	B, 13
	CALL	AXBHL
	LD	DE, TEXT_SINGLEPLAY
	ADD	HL, DE
	LD	D, 16		; \

	LD	BC, $35f1-80+11
	LD	E, 00100111B
	CALL	PRINT3

	RET

; -----------------------------------------------------------------------------
; Xe[^X\(G[EFς)
SHOW_STATUS_ERROR:
	LD	A, 00000010B		; ȏ
	LD	(SHOW_STATUS02+1), A
	JR	SHOW_STATUS01

; -----------------------------------------------------------------------------
; NG[bZ[W̕\
SHOW_INITIAL_STATUS:
	CALL	GET_DISKERRMES
	LD	B, 16
	CALL	SET_STRINGBUFFER	; obt@ɓ]

	LD	BC, $3000
	LD	D, WIDTH	; \
	LD	E, 00000111B	; Agr[g
	CALL	PRINT3

	EI
	HALT	; L[͂܂őҋ@

	RET

;------------------------------------------------------------------------------
; hCuԍy[W\
DRAW_DRIVE:
	LD	BC, FILELIST_DRAWSTART-WIDTH	; "Drive"̕\
	LD	HL, TEXT_DRIVE
	LD	D, 5		; \
	CALL	PRINT2

	INC	BC		; ꕶ

	LD	A, (CURRENTDRIVE)
	AND	00000011B		; hCuԍ擾

	ADD	A, $30			; $30=LN^[R[h"0"
	LD	D, A
	LD	E, 00000111B	; Agr[g
	CALL	PUTTEXT

	INC	BC
	INC	BC

	; y[W̕\
	LD	HL, TEXT_PAGE
	LD	D, 4		; \
	CALL	PRINT2

	INC	BC		; ꕶ

	LD	A, (NOWPAGE)
;	ADD	A, $30
	ADD	A, $31
	LD	D, A
	LD	E, 00000111B	; Agr[g
	CALL	PUTTEXT

	LD	D, "/"
	CALL	PUTTEXT

	LD	A, (MAXPAGE)
	AND	A
	JR	Z, CUTMAX
	DEC	A
CUTMAX:
;	ADD	A, $30
	ADD	A, $31
	LD	D, A
	CALL	PUTTEXT

	RET

; -----------------------------------------------------------------------------
; y^Cg̕\
DRAW_MTITLE:
	LD	BC, $35f1
	LD	HL, TEXT_TITLE
	CALL	PRINT

	LD	BC, $35f1+240
	LD	HL, TEXT_COMPOSER
	LD	D, 34		; \
	CALL	PRINT2

	LD	BC, $35f1+240+40
	LD	HL, TEXT_PROGRAMMER
	CALL	PRINT

	RET

; -----------------------------------------------------------------------------
MSTOP_CHECK_CORE:
	LD	A, (HL)
	AND	A
	RET	Z				; 0Ȃ܂t
	ADD	HL, DE
	DJNZ	MSTOP_CHECK_CORE
MSTOP_CHECK_CORE01:
	SCF
	RET

; -----------------------------------------------------------------------------
; tԂ`FbN
; CytOĂAtI
MSTOP_CHECK:
	LD	A, (NRTDRV_LOADADRS+$21)	; PLYFLG擾
	AND	A
	JR	Z, MSTOP_CHECK_CORE01		; PLYFLG=0Ȃ牉t~

	LD	DE, 52				; gbN[ÑTCY

	LD	A, (NRTDRV_LOADADRS+$1d)	; CTCtO
	BIT	0, A				; m[}FM݂邩H
	JR	Z, MSTOP_CHECK01

	; m[}FM̃`FbN
	LD	HL, NRTDRV_LOADADRS+40+47	; gbN[N擪+gbN~tOʒu
	LD	B, 8				; gbN
	CALL	MSTOP_CHECK_CORE
	RET	Z				; 0Ȃ܂t

MSTOP_CHECK01:
	LD	A, (NRTDRV_LOADADRS+$1d)	; CTCtO
	BIT	1, A				; FM
	JR	Z, MSTOP_CHECK02

	; FM̃`FbN
	LD	HL, NRTDRV_LOADADRS+40+463	; gbN[N擪+gbN~tOʒu(52*8+47)
	LD	B, 8				; gbN
	CALL	MSTOP_CHECK_CORE
	RET	Z				; 0Ȃ܂t

MSTOP_CHECK02:
	; PSG̃`FbN
	LD	HL, NRTDRV_LOADADRS+40+879	; gbN[N擪+gbN~tOʒu(52*16+47)
	LD	B, 3				; gbN
	CALL	MSTOP_CHECK_CORE

	RET

; -----------------------------------------------------------------------------
LOOP_CHECK_CORE:
	LD	DE, 52				; gbN[ÑTCY
LOOP_CHECK_CORE01:
	LD	A, (IX+47)			; gbN~tO
	CP	$ff
	JR	Z, LOOP_CHECK_CORE02		; ɉtIĂꍇ̓`FbNȂ
	LD	A, (IX+2)			; [vJE^
	CP	C
	RET	C
LOOP_CHECK_CORE02:
	ADD	IX, DE
	DJNZ	LOOP_CHECK_CORE01
	RET

; -----------------------------------------------------------------------------
LOOP_CHECK:
	LD	A, (NRTDRV_LOADADRS+$21)	; PLYFLG擾
	AND	A
	RET	Z				; PLYFLG=0Ȃ牉t~ԁB`FbN̕KvȂB

	LD	C, 2				; tF[hAEg郋[v

	LD	A, (NRTDRV_LOADADRS+$1d)	; CTCtO
	BIT	0, A				; m[}FM݂邩H
	JR	Z, LOOP_CHECK01

	; m[}FMgbÑ`FbN
	LD	IX, NRTDRV_LOADADRS+40		; gbN[N擪
	LD	B, 8
	CALL	LOOP_CHECK_CORE
	JR	C, LOOP_CHECK03

LOOP_CHECK01:
	LD	A, (NRTDRV_LOADADRS+$1d)	; CTCtO
	BIT	1, A				; FM݂邩H
	JR	Z, LOOP_CHECK02

	; FMgbÑ`FbN
	LD	HL, NRTDRV_LOADADRS+40+416	; gbN[N擪(52*8)
	LD	B, 8				; gbN
	CALL	LOOP_CHECK_CORE
	JR	C, LOOP_CHECK03

LOOP_CHECK02:
	; PSGgbÑ`FbN
	LD	HL, NRTDRV_LOADADRS+40+832	; gbN[N擪(52*16)
	LD	B, 3				; gbN
	CALL	LOOP_CHECK_CORE

LOOP_CHECK03:
	CCF

	RET

;------------------------------------------------------------------------------
include "lib\init.asm"			; VXe
include "lib\key.asm"			; L[͊荞
include "lib\screen.asm"		; ʕ\{
include "lib\general.asm"		; ėp[`
include "lib\pcg48.asm"			; 48{PCG`
include "lib\frame.asm"			; t[\
include "lib\string.asm"		; obt@
;------------------------------------------------------------------------------
include "lib\filelist.asm"		; t@CXg`
include "lib\diskapi.asm"		; fBXNANZXigp֐j
include "lib\filesys.asm"		; fBXNANZXit@CVXej
include "lib\diskbios.asm"		; fBXNANZXij
;------------------------------------------------------------------------------
PLAYMODE:		DB	$00	; 0=SINGLE/1=AUTO/2=REVERSE/3=RANDOM
NOWPLAYINDEX:		DB	$ff	; t̋ȃf[^indexl
ISLOADED:		DB	$00	; ȃf[^[hĂ邩H(0=[hĂȂ/̑=[hĂ)
;------------------------------------------------------------------------------
NRTDRV_LOGO:		DB	22,23,24,25,26,27,28,29,24,25,30,31
PCGFILE:		DB	"default.PCG", $00
FILENAME_DRV:		DB	"NRTDRV.BIN", $00
TEXT_HARDWARE:		DB	"Hardware", $00
TEXT_OPTION:		DB	"Option", $00
TEXT_STATUS:		DB	"Status", $00
TEXT_DRIVE:		DB	"Drive", $00
TEXT_PAGE		DB	"Page", $00
TEXT_TITLE:		DB	"Title", $00
TEXT_COMPOSER:		DB	"Composer", $00
TEXT_PROGRAMMER:	DB	"Programmer", $00
TEXT_SERIES:		DB	"series", $00
TEXT_OPMBOARD:		DB	"CZ-8BS1(MOD)", $00
TEXT_NONE:		DB	"none", $00
TEXT_TEST:		DB	"Test Tone", $00
TEXT_PLAY:		DB	"Play", $00
TEXT_STOP:		DB	"Stop/Idle", $00
TEXT_FADEOUT:		DB	"Fade Out", $00
TEXT_LOAD:		DB	"Loading...", $00
TEXT_UNKNOWN		DB	"???", $00
TEXT_CLEAR:		DB	" ", $00
TEXT_SINGLEPLAY:	DB	" SINGLE PLAY", $00
TEXT_AUTOPLAY:		DB	"   AUTO PLAY", $00
TEXT_REVERSEPLAY:	DB	"REVERSE PLAY", $00
TEXT_SHUFFLEPLAY:	DB	" RANDOM PLAY", $00
MSG_WAIT:		DB	"Please, Just wait...", $00
MSG_NOTINSERTED:	DB	"Drive Not Ready", $00
MSG_SEEKERROR:		DB	"Seek Error", $00
MSG_CRCERROR:		DB	"CRC Error", $00
MSG_DERROR:		DB	"Disk Error", $00
MSG_UNKNOWN:		DB	"Unknown Error", $00

END

