LINE_HORIZON	EQU	$90
LINE_VERTICAL	EQU	$91
LINE_RTOP	EQU	$9b
LINE_LBOTTOM	EQU	$9c
LINE_RBOTTOM	EQU	$9d
LINE_LTOP	EQU	$9e

; -----------------------------------------------------------------------------
; g\
; -----------------------------------------------------------------------------
; input: BC=\JnAhX
;         H=̕\vf
;         L=c̕\vf
DRAWFRAME:
	LD	E, 00000001B	; Agr[g

	LD	A, L		; c̕\pf

	PUSH	HL
	PUSH	BC
	CALL	DRAW_TOP	; 㕔`
	POP	BC
	CALL	GETNEXTPOS
	POP	HL

DRAWFRAME01:
	PUSH	HL
	PUSH	BC
	CALL	DRAW_MID	; `
	POP	BC
	CALL	GETNEXTPOS
	POP	HL

	DEC	A
	JR	NZ, DRAWFRAME01

DRAWFRAME02:
	PUSH	BC
	CALL	DRAW_BOTTOM	; `
	POP	BC

	RET

; -----------------------------------------------------------------------------
; Jng\
; -----------------------------------------------------------------------------
DRAW_TOP:
	LD	D, LINE_LTOP		; `
	CALL	PUTTEXT
	LD	D, LINE_HORIZON		; `
DRAW_TOP01:
	CALL	PUTTEXT
	DEC	H
	JP	NZ, DRAW_TOP01

	LD	D, LINE_RTOP		; E`
	CALL	PUTTEXT

	RET

; -----------------------------------------------------------------------------
; Ԙg\
; -----------------------------------------------------------------------------
DRAW_MID:
	LD	D, LINE_VERTICAL	; `
	CALL	PUTTEXT
DRAW_MID01:
	INC	BC			; t[͕`悵Ȃ
	DEC	H
	JR	NZ, DRAW_MID01

	LD	D, LINE_VERTICAL	; E`
	CALL	PUTTEXT

	RET

; -----------------------------------------------------------------------------
; g\
; -----------------------------------------------------------------------------
DRAW_BOTTOM:
	LD	D, LINE_LBOTTOM		; `
	CALL	PUTTEXT
	LD	D, LINE_HORIZON		; `
DRAW_BOTTOM01:
	CALL	PUTTEXT
	DEC	H
	JP	NZ, DRAW_BOTTOM01

	LD	D, LINE_RBOTTOM		; E`
	CALL	PUTTEXT

	RET

; -----------------------------------------------------------------------------
; s̍WԂ
; -----------------------------------------------------------------------------
GETNEXTPOS:
	LD	HL, 80
	ADD	HL, BC

	LD	B, H
	LD	C, L

	RET

