;==============================================================================
; ėp[`
;==============================================================================

;==============================================================================
; Tu[` ---- ADDHLA ... ADD HL, A
;------------------------------------------------------------------------------
; [] ..... HL=l1
;              A =l2i̐j
; [j] ..... AF/HL
; [o] ..... HL=HL+A
; [p] ... 
; [l] ..... 
;------------------------------------------------------------------------------
ADDHLA:					; HL+A (19/27)+17(call)
        ADD	A, L	; 4
        LD	L, A	; 4
        RET	NC	; 11/5
        INC	H	; 4
        RET		; 10

;==============================================================================
; Tu[` ---- AXBHL ... A~B=HL
;------------------------------------------------------------------------------
; [] ..... A =l1i̐j
;              B =l2i̐j
; [j] ..... AF/B/DE/HL
; [o] ..... HL=l1ƒl2̏Z̒l
; [p] ... 
; [l] ..... ASY͕MZ^Cv
;------------------------------------------------------------------------------
AXBHL:
	LD	HL, 0		; ʂNA
	LD	D, H		
	LD	E, B		; DE=B
	LD	B, 8		; 8bitԂJԂ(counter)
AXBHL00:
	RRCA			; ŉbitCyɓ
	JR	NC, AXBHL01	;
	ADD	HL, DE		; Cy=1ȂDE
AXBHL01:
	SLA	E
	RL	D		; DEVtg
	DJNZ	AXBHL00
	RET

;==============================================================================
; Tu[` ---- DIVHLBC ... HLBC=DE܂HL
;------------------------------------------------------------------------------
; [] ..... HL=l1i̐j
;              BC=l2i̐j
; [j] ..... AF/BC/DE/HL
; [o] ..... 
; [p] ... 
; [l] ..... 
;------------------------------------------------------------------------------
DIVHLBC:
	LD	A, B
	OR	C
	RET	Z		; BC=0̎̓G[(DIV/0)

	LD	DE, 0		; 
	AND	A		; CytOZbg
DIVHLBC01:
	SBC	HL, BC		
	JR	C, DIVHLBC02	; 甲
	INC	DE		; ++
	JR	DIVHLBC01
DIVHLBC02:
	ADD	HL, BC
	RET

;==============================================================================
; Tu[` ---- DIVAB ... AB=C܂A
;------------------------------------------------------------------------------
; [] ..... A =l1i̐j
;              B =l2i̐j
; [j] ..... AF/BC
; [o] ..... 
; [p] ... 
; [l] ..... 
;------------------------------------------------------------------------------
DIVAB:
	INC	B
	DEC	B
	RET	Z		; B=0̎̓G[(DIV0)

	LD	C, 0		; 
DIVAB01:
	SUB	B
	JR	C, DIVAB02 	; 甲
	INC	C		; ++
	JR	DIVAB01
DIVAB02:
	ADD	A, B
	RET

;==============================================================================
; Tu[` ---- FILLMEM ... 𓯂lŖ
;------------------------------------------------------------------------------
; [] ... A =l
;            HL=JnAhX
;            BC=JE^(TCY)
; [j] ... F/BC/DE/HL
; [o] ... A=0̎wŃ
;------------------------------------------------------------------------------
;FILLBUFFERA:
;	LD	HL, BUFFER
;	LD	BC, BUFFER_SIZE
;CLEARBUFFER:
;	XOR	A		; 
;------------------------------------------------------------------------------
;FILLMEM:
;	LD	D, H		; 4
;	LD	E, L		; 4
;	INC	DE		; 6	DE=]AhX
;	DEC	BC		; 
;	LD	(HL), A		; 	擪AhXɒ`
;	LDIR			; 	`AhX̓eDẼAhXɓ]
;	RET

